<ui:composition xmlns="http://www.w3.org/1999/xhtml" xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:f="http://java.sun.com/jsf/core" xmlns:h="http://java.sun.com/jsf/html"
  xmlns:cc="http://xmlns.jcp.org/jsf/composite" xmlns:p="http://primefaces.org/ui">
  <cc:interface>
    <cc:attribute name="value" required="true" type="java.lang.String" />
    <cc:attribute name="type" required="false" default="plain" type="java.lang.String" shortDescription="one of plain (default), translation, locales or of t_functioninputtype.name" />
    <cc:attribute name="width" required="false" default="100%" type="java.lang.String" />
    <cc:attribute name="typerestriction" required="false" default="{}" type="java.lang.String" />
    <cc:attribute name="labelall" required="false" default="" type="java.lang.String" shortDescription="the button label to display all translations" />
    <cc:attribute name="update" required="false" default="" type="java.lang.String" shortDescription="the component(s) to update with ajax" />
  </cc:interface>
  <cc:implementation>
    <h:panelGrid id="container" columns="1">
      <ui:fragment rendered="#{TypeRestrictionHelper.findBoolean(cc.attrs.typerestriction, 'read_only')}">
        <h:outputText value="unchangeable" />
        <!-- TODO: translate -->
      </ui:fragment>
      <!-- see wiki page of Square² for typerestrictions -->
      <ui:fragment rendered="#{!TypeRestrictionHelper.findBoolean(cc.attrs.typerestriction, 'read_only')}">
        <h:outputScript library="js" name="inputjson.js?version=#{appl.getVersion(facesContext)}" target="head" />
        <h:inputText id="outputField" value="#{cc.attrs.value}" style="display: none">
          <p:ajax update="#{cc.attrs.update}" disabled="#{cc.attrs.update == ''}" />
        </h:inputText>
        <div id="#{cc.attrs.clientId}:inputjson"></div>
        <script type="text/javascript">
    		  var type = '#{cc.attrs.type}';
    		  // plain options
    		  var typerestriction = #{cc.attrs.typerestriction};
    		  var wippattern = "{isocode: translation, isocode: translation, ...}, encapsulated by double quotes";
    		
    		  if (type == "translation") {
    			  if (typerestriction == "{}") {
    			    typerestriction = {"en": "English"};
    			  }
    			  wippattern = "";
    		  }
    		  
    		  // type == locales uses icons to add and remove elements
    			var iconclasses = {"trash": "fa fa-trash", "plus": "fa fa-plus"};
  
    			new libs.InputJson(document.getElementById("#{cc.attrs.clientId}:inputjson"),
    			                   document.getElementById("#{cc.attrs.clientId}:outputField"),
    			                   type,
    			                   typerestriction,
    			                   "#{cc.attrs.width}",
    			                   wippattern,
    			                   "#{cc.attrs.labelall}",
    			                   iconclasses);
    		</script>
      </ui:fragment>
    </h:panelGrid>
  </cc:implementation>
</ui:composition>